;Przykładowy program POOL, możesz go używać,
;modyfikować i rozpowszechniać na licencji GPL.
;Autorzy: R&D Independent Team
;Źródło: www.pool-rnd.com

window ht
:pool_cfg,"refresh := false
:pool_cfg,"scale_x := 50
:pool_cfg,"scale_y := 50

;początkowe wartości współczynników A, B, C:
"a := 1
"b := 1
"c := 0

to f :x ;f(x) = A*x^2 + B*x + C
  op :a * :x^2 + :b * :x + :c
end

;funkcja rozwiązująca równanie A*x^2 + B*x + C = 0
;wynikiem jest tablica:
;{delta} - jeśli A = 0 i B = 0 lub delta < 0
;{delta, x1} - jeśli A = 0 i B <> 0 (równanie liniowe)
;{delta, x1, x2} - jeśli delta >= 0
to solve
  let "d :b^2 - 4 * :a * :c ;delta równania
  if :a = 0 [
    ifelse :b = 0 [op (array :d)]
    [op array :d (-:c/:b)]
  ]
  if :d >= 0 [
    let "x1 (-:b - sqrt :d) / (2 * :a)
    let "x2 (-:b + sqrt :d) / (2 * :a)
    op (array :d :x1 :x2)
  ]
  op (array :d)
end

to circle :x ;funkcja rysująca okrąg w punkcie (:x, 0)
  (setpc "red 50)
  pu setxy :x 0
  arc 360 10 / :pool_cfg,"scale_x ;promień zależy od skali rysowania
end

to draw_f :x0 :x1 :n ;funkcja rysująca wykres
  setpc {30 0 20}
  pu setxy :x0 f :x0 pd
  for [x :x0 :x1 [(:x1 - :x0)/:n]] [setxy :x f :x]
end

to update
  clean
  draw_f :pool_inf,"wall_left :pool_inf,"wall_right 300
  let "r solve
  settext :ld word "|d = | :r,1
  ifelse count :r > 1 [
    settext :l1 word "|x1 = | :r,2
    circle :r,2
    ifelse count :r > 2 [
      circle :r,3
      settext :l2 word "|x2 = | :r,3
    ] [settext :l2 "|---|]
  ] [
    settext :l1 "|---|
    settext :l2 "|---|
  ]
  refresh
end

to onworldchanged
  update
end

;etykiety z roziązaniami równania:
"l1 := label "x1 {70 6 200 24}
"l2 := label "x2 {70 34 200 24}
"ld := label "delta {70 62 200 24}

;suwaki sterujące współczynnikami A, B i C,
;tu możesz zmienić zakres współczynników
"sa := (slider "A {70 100} {-10 10} :a)
setonchange :sa ["a := getvalue :sa update]
"sb := (slider "B {70 150} {-10 10} :b)
setonchange :sb ["b := getvalue :sb update]
"sc := (slider "C {70 200} {-5 5} :c)
setonchange :sc ["c := getvalue :sc update]

update

